local SpawnPrefab = GLOBAL.SpawnPrefab
local IsSpecialEventActive = GLOBAL.IsSpecialEventActive
local SPECIAL_EVENTS = GLOBAL.SPECIAL_EVENTS
GLOBAL.require("prefabs/winter_ornaments")
GLOBAL.require("recipe")
GLOBAL.require("prefabs/wickerbottom")


AddPrefabPostInit("deerclops", function(inst) --postinit adds lines to a prefab i think
    if not GLOBAL.TheWorld.ismastersim then 
        return inst 
    end; 
    
    clopsyloot = {"meat","meat","meat","meat","meat","meat","meat","meat","deerclops_eyeball","eyebrellahat_blueprint"}
    inst.components.lootdropper:SetLoot(clopsyloot) --setloot's loot has to be a table
end)

AddPrefabPostInit("bearger", function(inst)
    if not GLOBAL.TheWorld.ismastersim then
        return inst
    end;

    inst.components.lootdropper:AddChanceLoot(math.random() < 0.5 and "beargervest_blueprint" or "icepack_blueprint", 1.0)
end)-- condition and iftruethendo or iffalsethendo

AddPrefabPostInit("moose", function(inst)
    if not GLOBAL.TheWorld.ismastersim then
        return inst
    end;

    inst.components.lootdropper:AddChanceLoot(math.random() < 0.5 and "staff_tornado_blueprint" or "featherfan_blueprint", 0.3)
end)

AddPrefabPostInit("dragonfly", function(inst)
    if not GLOBAL.TheWorld.ismastersim then
        return inst
    end;

    local dragonprint = GLOBAL.GetRandomItem({ "dragonflychest_blueprint", "armordragonfly_blueprint", "turf_dragonfly_blueprint" })
    inst.components.lootdropper:AddChanceLoot(dragonprint, 1.0)
end)

AddPrefabPostInit("toadstool", function(inst)
    if not GLOBAL.TheWorld.ismastersim then
        return inst
    end;

    inst.components.lootdropper:AddChanceLoot("blueprint", 1)
    inst.components.lootdropper:AddChanceLoot("blueprint", 1)
    inst.components.lootdropper:AddChanceLoot("blueprint", 1)
    inst.components.lootdropper:AddChanceLoot("blueprint", 1)
    inst.components.lootdropper:AddChanceLoot("blueprint", 1)
end)

AddPrefabPostInit("spider", function(inst)
    if not GLOBAL.TheWorld.ismastersim then
        return inst
    end;

    inst.components.lootdropper:AddChanceLoot("lifeinjector_blueprint", 0.001)
    inst.components.lootdropper:AddChanceLoot("blueprint", 0.0001)
end)

AddPrefabPostInit("walrus", function(inst)
    if not GLOBAL.TheWorld.ismastersim then
        return inst
    end;

    inst.components.lootdropper:AddChanceLoot("cane_blueprint", 0.1)
end)

AddPrefabPostInit("warg", function(inst)
    if not GLOBAL.TheWorld.ismastersim then
        return inst
    end;
    wargprint = GLOBAL.GetRandomItem({"trap_teeth_blueprint", "sewing_kit_blueprint"})
    inst.components.lootdropper:AddChanceLoot(wargprint, 0.05)
end)

AddPrefabPostInit("spat", function(inst)
    if not GLOBAL.TheWorld.ismastersim then
        return inst
    end;
    spatprint = GLOBAL.GetRandomItem({"saddle_war_blueprint", "brush_blueprint"})
    inst.components.lootdropper:AddChanceLoot(spatprint, 0.05)
end)



AddPrefabPostInit("klaus_sack", function(inst)
    if not GLOBAL.TheWorld.ismastersim then
        return inst
    end;
local prefabs =
{
    "klaus",
    "boneshard",
    "bundle",
    "gift",

    --loot
    "krampus_sack",
    "charcoal",
    "goldnugget",
    "amulet",

    --winter loot
    "goatmilk",
    "winter_food1", --gingerbread cookies
    "winter_food2", --sugar cookies
}

local giant_loot1 =
{
    "deerclops_eyeball",
    "dragon_scales",
    "hivehat",
    "shroom_skin",
    "mandrake",
}

local giant_loot2 =
{
    "dragonflyfurnace_blueprint",
    "red_mushroomhat_blueprint",
    "green_mushroomhat_blueprint",
    "blue_mushroomhat_blueprint",
    "mushroom_light2_blueprint",
    "mushroom_light_blueprint",
    "townportal_blueprint",
    "bundlewrap_blueprint",
}

local giant_loot3 =
{
    "bearger_fur",
    "royal_jelly",
    "goose_feather",
    "lavae_egg",
    "spiderhat",
    "steelwool",
    "townportaltalisman",
}

for i, v in ipairs(giant_loot1) do
    table.insert(prefabs, v)
end

for i, v in ipairs(giant_loot2) do
    table.insert(prefabs, v)
end

for i, v in ipairs(giant_loot3) do
    table.insert(prefabs, v)
end

for i, v in ipairs(GLOBAL.GetAllWinterOrnamentPrefabs()) do
    table.insert(prefabs, v)
end

    lesitems = {}
    local function FillItems(items, prefab)
        for i = 1 + #items, math.random(3, 4) do
        table.insert(items, SpawnPrefab(prefab))
        end
    end
        function DropBundle(inst, items)
            local bundle = SpawnPrefab(GLOBAL.IsSpecialEventActive(GLOBAL.SPECIAL_EVENTS.WINTERS_FEAST) and "gift" or "bundle")
            bundle.components.unwrappable:WrapItems(items)
             for i, v in ipairs(items) do
                v:Remove()
             end
         inst.components.lootdropper:FlingItem(bundle)
     end
    local function onuseklauskey(inst, key, doer)
    if key.components.klaussackkey == nil then
        return false
    elseif key.components.klaussackkey.truekey then
        if inst.components.entitytracker:GetEntity("klaus") ~= nil then
            --klaus is already spawned
            --announce danger?
            return false, "KLAUS", false
        end

        inst.AnimState:PlayAnimation("open")
        inst.SoundEmitter:PlaySound("dontstarve/creatures/together/klaus/chain_foley")
        inst.SoundEmitter:PlaySound("dontstarve/creatures/together/klaus/lock_break")

        if IsSpecialEventActive(SPECIAL_EVENTS.WINTERS_FEAST) then
            local rnd = math.random(3)
            local items =
            {
                SpawnPrefab(GetRandomBasicWinterOrnament()),
                SpawnPrefab(GetRandomFancyWinterOrnament()),
                SpawnPrefab(GetRandomLightWinterOrnament()),
                SpawnPrefab(
                    (rnd == 1 and GetRandomLightWinterOrnament()) or
                    (rnd == 2 and GetRandomFancyWinterOrnament()) or
                    GetRandomBasicWinterOrnament()
                ),
            }
            DropBundle(inst, items)

            items =
            {
                SpawnPrefab("goatmilk"),
                SpawnPrefab("goatmilk"),
                SpawnPrefab("winter_food"..tostring(math.random(2))),
            }
            items[3].components.stackable.stacksize = 4
            DropBundle(inst, items)
        end

        local items = {}
        table.insert(items, SpawnPrefab("amulet"))
        table.insert(items, SpawnPrefab("goldnugget"))
        FillItems(items, "charcoal")
        DropBundle(inst, items)

        items = {}
        if math.random() < .5 then
            table.insert(items, SpawnPrefab("amulet"))
        end
        table.insert(items, SpawnPrefab("goldnugget"))
        FillItems(items, "charcoal")
        DropBundle(inst, items)

        items = {}
        if math.random() < .1 then
            table.insert(items, SpawnPrefab("krampus_sack"))
        end
        table.insert(items, SpawnPrefab("goldnugget"))
        FillItems(items, "charcoal")
        DropBundle(inst, items)

        items = {}
        local i1 = math.random(#giant_loot3)
        local i2 = math.random(#giant_loot3 - 1)
        table.insert(items, SpawnPrefab(giant_loot1[math.random(#giant_loot1)]))
        if math.random() < .5 then
            table.insert(items, SpawnPrefab(giant_loot2[math.random(#giant_loot2)]))
        end
        table.insert(items, SpawnPrefab(giant_loot3[i1]))
        table.insert(items, SpawnPrefab(giant_loot3[i2 == i1 and i2 + 1 or i2]))
        DropBundle(inst, items)    
        items = {GLOBAL.SpawnPrefab("blueprint"),GLOBAL.SpawnPrefab("blueprint"),GLOBAL.SpawnPrefab("blueprint"),GLOBAL.SpawnPrefab("blueprint")}
        DropBundle(inst, items)
        inst.persists = false
        inst:AddTag("NOCLICK")
        inst:DoTaskInTime(1, GLOBAL.ErodeAway)

        return true, nil, true
    else
        GLOBAL.LaunchAt(SpawnPrefab("boneshard"), inst, doer, .2, 1, 1)

        inst.AnimState:PlayAnimation("jiggle")
        inst.AnimState:PushAnimation("idle", false)
        inst.SoundEmitter:PlaySound("dontstarve/creatures/together/deer/chain")

        if inst.components.entitytracker:GetEntity("klaus") ~= nil then
            --klaus is already spawned
            --announce danger?
        elseif inst.components.entitytracker:GetEntity("key") ~= nil then
            --already got the right key
            --announce that this isn't the right key
        else
            --Find spawn point far away, preferrably not near players
            local pos = inst:GetPosition()
            local minplayers = math.huge
            local spawnx, spawnz
            GLOBAL.FindWalkableOffset(pos,
                math.random() * 2 * GLOBAL.PI, 33, 16, true, true,
                function(pt)
                    local count = #GLOBAL.FindPlayersInRangeSq(pt.x, pt.y, pt.z, 625)
                    if count < minplayers then
                        minplayers = count
                        spawnx, spawnz = pt.x, pt.z
                        return count <= 0
                    end
                    return false
                end)

            if spawnx == nil then
                --No spawn point (with or without players), so try closer
                local offset = GLOBAL.FindWalkableOffset(pos, math.random() * 2 * GLOBAL.PI, 3, 8, false, true)
                if offset ~= nil then
                    spawnx, spawnz = pos.x + offset.x, pos.z + offset.z
                end
            end

            local klaus = SpawnPrefab("klaus")
            klaus.Transform:SetPosition(spawnx or pos.x, 0, spawnz or pos.z)
            klaus:SpawnDeer()
            -- override the spawn point so klaus comes to his sack
            klaus.components.knownlocations:RememberLocation("spawnpoint", pos, false)
            klaus.components.spawnfader:FadeIn()

            inst.components.entitytracker:TrackEntity("klaus", klaus)
            inst:ListenForEvent("dropkey", inst.OnDropKey, klaus)
        end
        return false, "WRONGKEY", true
    end
end
    inst.components.klaussacklock:SetOnUseKey(onuseklauskey)
end)

AddPrefabPostInit("wickerbottom", function(inst)
    if not GLOBAL.TheWorld.ismastersim then
        return inst
    end;


    inst.components.eater.stale_hunger = TUNING.STALE_FOOD_HUNGER
    inst.components.eater.stale_health = TUNING.STALE_FOOD_HEALTH
    inst.components.eater.spoiled_hunger = TUNING.SPOILED_FOOD_HUNGER
    inst.components.eater.spoiled_health = TUNING.SPOILED_FOOD_HEALTH

    inst.components.sanity:SetMax(TUNING.WICKERBOTTOM_SANITY)

    inst.components.builder.science_bonus = 0


    inst.components.builder:UnlockRecipe("papyrus")

end)

AddPrefabPostInit("researchlab", function(inst)
    if not GLOBAL.TheWorld.ismastersim then
        return inst
    end;

    inst:RemoveTag("prototyper")

end)

AddPrefabPostInit("researchlab2", function(inst)
    if not GLOBAL.TheWorld.ismastersim then
        return inst
    end;

    inst:RemoveTag("prototyper")

end)

ListOfMobs1 = {"hound","frog","pigman","beefalo","babybeefalo","perd","merm","monkey","lightninggoat"}

for k, v in pairs(ListOfMobs1) do 
    AddPrefabPostInit(v, function(inst)
        if not GLOBAL.TheWorld.ismastersim then
            return inst
        end;

        inst.components.lootdropper:AddChanceLoot("blueprint", 0.005)
    end)
end

ListOfMobs2 = {"warg", "spat", "koalefant_summer", "koalefant_winter"}

for k, v in pairs(ListOfMobs2) do 
    AddPrefabPostInit(v, function(inst)
        if not GLOBAL.TheWorld.ismastersim then
            return inst
        end;

        inst.components.lootdropper:AddChanceLoot("blueprint", 0.1)
    end)
end

Recipe("book_birds", {Ingredient("papyrus", 2), Ingredient("bird_egg", 2)}, GLOBAL.CUSTOM_RECIPETABS.BOOKS, GLOBAL.TECH.MAGIC_TWO, nil, nil, nil, nil, "bookbuilder")
Recipe("book_gardening", {Ingredient("papyrus", 2), Ingredient("seeds", 1), Ingredient("poop", 1)}, GLOBAL.CUSTOM_RECIPETABS.BOOKS, GLOBAL.TECH.NONE, nil, nil, nil, nil, "bookbuilder")
Recipe("book_sleep", {Ingredient("papyrus", 2), Ingredient("nightmarefuel", 2)}, GLOBAL.CUSTOM_RECIPETABS.BOOKS, GLOBAL.TECH.NONE, nil, nil, nil, nil, "bookbuilder")
Recipe("book_brimstone", {Ingredient("papyrus", 2), Ingredient("redgem", 1)}, GLOBAL.CUSTOM_RECIPETABS.BOOKS, GLOBAL.TECH.NONE, nil, nil, nil, nil, "bookbuilder")
Recipe("book_tentacles", {Ingredient("papyrus", 2), Ingredient("tentaclespots", 1)}, GLOBAL.CUSTOM_RECIPETABS.BOOKS, GLOBAL.TECH.NONE, nil, nil, nil, nil, "bookbuilder")
Recipe("researchlab", {Ingredient("goldnugget", 1),Ingredient("log", 4),Ingredient("rocks", 4)}, nil, GLOBAL.TECH.LOST, nil, nil, true)
Recipe("researchlab2", {Ingredient("boards", 4),Ingredient("cutstone", 2), Ingredient("transistor", 2)}, nil, GLOBAL.TECH.LOST, nil, nil, true)